# **************************
# *                        *
# *  Gyorgyi Csaba         *
# *  gycsaba96@gmail.com   *
# *  2016.03.24            *
# *                        *
# **************************

import networkx as nx			# grafok kezelese
import matplotlib.pyplot as plt		# kirajzolas
import datetime				# datum-ido az egyedi fajlnevekhez

MAXCSUCS=5	# csucsok maximalis szama

osszes=[]	# a generalt grafok tarolasara szolgalo tomb

# Megmondja egy parameterul kapott grafrol, hogy generaltunk-e mar vele izomorfat.
# Parametere egy graf
def meg_nem_szerepel(F):
  global osszes
  ok=True
  for H in osszes:
     if (nx.is_isomorphic(F,H)):
       ok=False
  return ok

# A meglevo G grafhoz az uid csucsal boviti, ugy, hogy az idk-ban meghatarozott csucsokkal legyen kozos ele (ahol idk[i]==1)
def addKapcsolt(G,uid,idk):
  G.add_node(uid)
  for kid in range(len(idk)):
    if idk[kid]==1:
      G.add_edge(uid,kid)
  return nx.Graph(G)

# eloallitja az osszes n elemu csak 1-est es 0-t tartalmazo sorozatot
def getBinarisPermutacio(eddig,n): 
  u0=[]
  for a in eddig:
      u0=u0+[a+[0]]  
  u1=[]
  for a in eddig:      
      u1=u1+[a+[1]]
  if n==0:
    return eddig
  else:
    return getBinarisPermutacio(u0+u1,n-1)

# rekurzivan eloallitja a G grafbol a maximum MAXCSUCS csucsu grafokat (n G csucsainak szama)
def Vizsgal(G,n):
  global osszes
  global MAXCSUCS
  if meg_nem_szerepel(nx.Graph(G)):
    print len(osszes)
    osszes=osszes+[nx.Graph(G)]
    print len(osszes)
    for a in getBinarisPermutacio([[]],n):
      if n<MAXCSUCS:
	Vizsgal(addKapcsolt(nx.Graph(G),n,a),n+1)

# megadja, a parameterul kapott graf izomorf-e a komplementerevl
def Kulonbozik(G):
  if nx.is_isomorphic(nx.Graph(G),nx.Graph(nx.complement(nx.Graph(G)))):
    return False
  else:
    return True

# *** FOPROGRAM *** 

# kiindulo 1 csucsu graf eloallitasa
G=nx.Graph()
G.add_node(0)
#az osszes graf eloallitasa
Vizsgal(nx.Graph(G),1)

#grafok vizsgalata es mentese kepkent
for graf in osszes:
  if Kulonbozik(nx.Graph(graf)):
    plt.clf()
    nx.draw(graf)
    plt.savefig("graf_"+str(len(graf.nodes()))+"_kulonbozik_"+str(datetime.datetime.now())+".png")
    plt.clf()
    print "+"
  else:
    plt.clf()
    nx.draw(graf)
    plt.savefig("graf_"+str(len(graf.nodes()))+"_egyezik_"+str(datetime.datetime.now())+".png")
    plt.clf()
    print "+"
    